/*
 *  This file is part of the WebKit open source project.
 *  This file has been generated by generate-bindings.pl. DO NOT MODIFY!
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#include "config.h"
#include "WebKitDOMBarProp.h"

#include "CSSImportRule.h"
#include "DOMObjectCache.h"
#include "Document.h"
#include "ExceptionCode.h"
#include "ExceptionCodeDescription.h"
#include "JSMainThreadExecState.h"
#include "WebKitDOMBarPropPrivate.h"
#include "WebKitDOMPrivate.h"
#include "gobject/ConvertToUTF8String.h"
#include <wtf/GetPtr.h>
#include <wtf/RefPtr.h>

#define WEBKIT_DOM_BAR_PROP_GET_PRIVATE(obj) G_TYPE_INSTANCE_GET_PRIVATE(obj, WEBKIT_DOM_TYPE_BAR_PROP, WebKitDOMBarPropPrivate)

typedef struct _WebKitDOMBarPropPrivate {
    RefPtr<WebCore::BarProp> coreObject;
} WebKitDOMBarPropPrivate;

namespace WebKit {

WebKitDOMBarProp* kit(WebCore::BarProp* obj)
{
    if (!obj)
        return 0;

    if (gpointer ret = DOMObjectCache::get(obj))
        return WEBKIT_DOM_BAR_PROP(ret);

    return wrapBarProp(obj);
}

WebCore::BarProp* core(WebKitDOMBarProp* request)
{
    return request ? static_cast<WebCore::BarProp*>(WEBKIT_DOM_OBJECT(request)->coreObject) : 0;
}

WebKitDOMBarProp* wrapBarProp(WebCore::BarProp* coreObject)
{
    ASSERT(coreObject);
    return WEBKIT_DOM_BAR_PROP(g_object_new(WEBKIT_DOM_TYPE_BAR_PROP, "core-object", coreObject, nullptr));
}

} // namespace WebKit

G_DEFINE_TYPE(WebKitDOMBarProp, webkit_dom_bar_prop, WEBKIT_DOM_TYPE_OBJECT)

enum {
    PROP_0,
    PROP_VISIBLE,
};

static void webkit_dom_bar_prop_finalize(GObject* object)
{
    WebKitDOMBarPropPrivate* priv = WEBKIT_DOM_BAR_PROP_GET_PRIVATE(object);

    WebKit::DOMObjectCache::forget(priv->coreObject.get());

    priv->~WebKitDOMBarPropPrivate();
    G_OBJECT_CLASS(webkit_dom_bar_prop_parent_class)->finalize(object);
}

static void webkit_dom_bar_prop_get_property(GObject* object, guint propertyId, GValue* value, GParamSpec* pspec)
{
    WebKitDOMBarProp* self = WEBKIT_DOM_BAR_PROP(object);

    switch (propertyId) {
    case PROP_VISIBLE:
        g_value_set_boolean(value, webkit_dom_bar_prop_get_visible(self));
        break;
    default:
        G_OBJECT_WARN_INVALID_PROPERTY_ID(object, propertyId, pspec);
        break;
    }
}

static GObject* webkit_dom_bar_prop_constructor(GType type, guint constructPropertiesCount, GObjectConstructParam* constructProperties)
{
    GObject* object = G_OBJECT_CLASS(webkit_dom_bar_prop_parent_class)->constructor(type, constructPropertiesCount, constructProperties);

    WebKitDOMBarPropPrivate* priv = WEBKIT_DOM_BAR_PROP_GET_PRIVATE(object);
    priv->coreObject = static_cast<WebCore::BarProp*>(WEBKIT_DOM_OBJECT(object)->coreObject);
    WebKit::DOMObjectCache::put(priv->coreObject.get(), object);

    return object;
}

static void webkit_dom_bar_prop_class_init(WebKitDOMBarPropClass* requestClass)
{
    GObjectClass* gobjectClass = G_OBJECT_CLASS(requestClass);
    g_type_class_add_private(gobjectClass, sizeof(WebKitDOMBarPropPrivate));
    gobjectClass->constructor = webkit_dom_bar_prop_constructor;
    gobjectClass->finalize = webkit_dom_bar_prop_finalize;
    gobjectClass->get_property = webkit_dom_bar_prop_get_property;

    g_object_class_install_property(
        gobjectClass,
        PROP_VISIBLE,
        g_param_spec_boolean(
            "visible",
            "BarProp:visible",
            "read-only gboolean BarProp:visible",
            FALSE,
            WEBKIT_PARAM_READABLE));

}

static void webkit_dom_bar_prop_init(WebKitDOMBarProp* request)
{
    WebKitDOMBarPropPrivate* priv = WEBKIT_DOM_BAR_PROP_GET_PRIVATE(request);
    new (priv) WebKitDOMBarPropPrivate();
}

gboolean webkit_dom_bar_prop_get_visible(WebKitDOMBarProp* self)
{
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_BAR_PROP(self), FALSE);
    WebCore::BarProp* item = WebKit::core(self);
    gboolean result = item->visible();
    return result;
}

