/*
 *  This file is part of the WebKit open source project.
 *  This file has been generated by generate-bindings.pl. DO NOT MODIFY!
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#include "config.h"
#include "WebKitDOMFile.h"

#include "CSSImportRule.h"
#include "DOMObjectCache.h"
#include "Document.h"
#include "ExceptionCode.h"
#include "ExceptionCodeDescription.h"
#include "JSMainThreadExecState.h"
#include "WebKitDOMBlobPrivate.h"
#include "WebKitDOMFilePrivate.h"
#include "WebKitDOMPrivate.h"
#include "gobject/ConvertToUTF8String.h"
#include "WebKitDOMFileUnstable.h"
#include <wtf/GetPtr.h>
#include <wtf/RefPtr.h>

namespace WebKit {

WebKitDOMFile* kit(WebCore::File* obj)
{
    return WEBKIT_DOM_FILE(kit(static_cast<WebCore::Blob*>(obj)));
}

WebCore::File* core(WebKitDOMFile* request)
{
    return request ? static_cast<WebCore::File*>(WEBKIT_DOM_OBJECT(request)->coreObject) : 0;
}

WebKitDOMFile* wrapFile(WebCore::File* coreObject)
{
    ASSERT(coreObject);
    return WEBKIT_DOM_FILE(g_object_new(WEBKIT_DOM_TYPE_FILE, "core-object", coreObject, nullptr));
}

} // namespace WebKit

G_DEFINE_TYPE(WebKitDOMFile, webkit_dom_file, WEBKIT_DOM_TYPE_BLOB)

enum {
    PROP_0,
    PROP_NAME,
    PROP_LAST_MODIFIED,
};

static void webkit_dom_file_get_property(GObject* object, guint propertyId, GValue* value, GParamSpec* pspec)
{
    WebKitDOMFile* self = WEBKIT_DOM_FILE(object);

    switch (propertyId) {
    case PROP_NAME:
        g_value_take_string(value, webkit_dom_file_get_name(self));
        break;
    case PROP_LAST_MODIFIED:
        g_value_set_int64(value, webkit_dom_file_get_last_modified(self));
        break;
    default:
        G_OBJECT_WARN_INVALID_PROPERTY_ID(object, propertyId, pspec);
        break;
    }
}

static void webkit_dom_file_class_init(WebKitDOMFileClass* requestClass)
{
    GObjectClass* gobjectClass = G_OBJECT_CLASS(requestClass);
    gobjectClass->get_property = webkit_dom_file_get_property;

    g_object_class_install_property(
        gobjectClass,
        PROP_NAME,
        g_param_spec_string(
            "name",
            "File:name",
            "read-only gchar* File:name",
            "",
            WEBKIT_PARAM_READABLE));

    g_object_class_install_property(
        gobjectClass,
        PROP_LAST_MODIFIED,
        g_param_spec_int64(
            "last-modified",
            "File:last-modified",
            "read-only gint64 File:last-modified",
            G_MININT64, G_MAXINT64, 0,
            WEBKIT_PARAM_READABLE));

}

static void webkit_dom_file_init(WebKitDOMFile* request)
{
    UNUSED_PARAM(request);
}

gchar* webkit_dom_file_get_name(WebKitDOMFile* self)
{
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_FILE(self), 0);
    WebCore::File* item = WebKit::core(self);
    gchar* result = convertToUTF8String(item->name());
    return result;
}

gint64 webkit_dom_file_get_last_modified(WebKitDOMFile* self)
{
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_FILE(self), 0);
    WebCore::File* item = WebKit::core(self);
    gint64 result = item->lastModified();
    return result;
}

