/*
 *  This file is part of the WebKit open source project.
 *  This file has been generated by generate-bindings.pl. DO NOT MODIFY!
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#include "config.h"
#include "WebKitDOMHTMLAudioElement.h"

#include "CSSImportRule.h"
#include "DOMObjectCache.h"
#include "Document.h"
#include "ExceptionCode.h"
#include "ExceptionCodeDescription.h"
#include "GObjectEventListener.h"
#include "JSMainThreadExecState.h"
#include "WebKitDOMEventPrivate.h"
#include "WebKitDOMEventTarget.h"
#include "WebKitDOMHTMLAudioElementPrivate.h"
#include "WebKitDOMNodePrivate.h"
#include "WebKitDOMPrivate.h"
#include "gobject/ConvertToUTF8String.h"
#include <wtf/GetPtr.h>
#include <wtf/RefPtr.h>

#if ENABLE(VIDEO)

namespace WebKit {

WebKitDOMHTMLAudioElement* kit(WebCore::HTMLAudioElement* obj)
{
    return WEBKIT_DOM_HTML_AUDIO_ELEMENT(kit(static_cast<WebCore::Node*>(obj)));
}

WebCore::HTMLAudioElement* core(WebKitDOMHTMLAudioElement* request)
{
    return request ? static_cast<WebCore::HTMLAudioElement*>(WEBKIT_DOM_OBJECT(request)->coreObject) : 0;
}

WebKitDOMHTMLAudioElement* wrapHTMLAudioElement(WebCore::HTMLAudioElement* coreObject)
{
    ASSERT(coreObject);
    return WEBKIT_DOM_HTML_AUDIO_ELEMENT(g_object_new(WEBKIT_DOM_TYPE_HTML_AUDIO_ELEMENT, "core-object", coreObject, nullptr));
}

} // namespace WebKit

#endif // ENABLE(VIDEO)

static gboolean webkit_dom_html_audio_element_dispatch_event(WebKitDOMEventTarget* target, WebKitDOMEvent* event, GError** error)
{
#if ENABLE(VIDEO)
    WebCore::Event* coreEvent = WebKit::core(event);
    if (!coreEvent)
        return false;
    WebCore::HTMLAudioElement* coreTarget = static_cast<WebCore::HTMLAudioElement*>(WEBKIT_DOM_OBJECT(target)->coreObject);

    WebCore::ExceptionCode ec = 0;
    gboolean result = coreTarget->dispatchEventForBindings(*coreEvent, ec);
    if (ec) {
        WebCore::ExceptionCodeDescription description(ec);
        g_set_error_literal(error, g_quark_from_string("WEBKIT_DOM"), description.code, description.name);
    }
    return result;
#else
    UNUSED_PARAM(target);
    UNUSED_PARAM(event);
    UNUSED_PARAM(error);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video")
    return false;
#endif // ENABLE(VIDEO)
}

static gboolean webkit_dom_html_audio_element_add_event_listener(WebKitDOMEventTarget* target, const char* eventName, GClosure* handler, gboolean useCapture)
{
#if ENABLE(VIDEO)
    WebCore::HTMLAudioElement* coreTarget = static_cast<WebCore::HTMLAudioElement*>(WEBKIT_DOM_OBJECT(target)->coreObject);
    return WebCore::GObjectEventListener::addEventListener(G_OBJECT(target), coreTarget, eventName, handler, useCapture);
#else
    UNUSED_PARAM(target);
    UNUSED_PARAM(eventName);
    UNUSED_PARAM(handler);
    UNUSED_PARAM(useCapture);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video")
    return false;
#endif // ENABLE(VIDEO)
}

static gboolean webkit_dom_html_audio_element_remove_event_listener(WebKitDOMEventTarget* target, const char* eventName, GClosure* handler, gboolean useCapture)
{
#if ENABLE(VIDEO)
    WebCore::HTMLAudioElement* coreTarget = static_cast<WebCore::HTMLAudioElement*>(WEBKIT_DOM_OBJECT(target)->coreObject);
    return WebCore::GObjectEventListener::removeEventListener(G_OBJECT(target), coreTarget, eventName, handler, useCapture);
#else
    UNUSED_PARAM(target);
    UNUSED_PARAM(eventName);
    UNUSED_PARAM(handler);
    UNUSED_PARAM(useCapture);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video")
    return false;
#endif // ENABLE(VIDEO)
}

static void webkit_dom_event_target_init(WebKitDOMEventTargetIface* iface)
{
    iface->dispatch_event = webkit_dom_html_audio_element_dispatch_event;
    iface->add_event_listener = webkit_dom_html_audio_element_add_event_listener;
    iface->remove_event_listener = webkit_dom_html_audio_element_remove_event_listener;
}

G_DEFINE_TYPE_WITH_CODE(WebKitDOMHTMLAudioElement, webkit_dom_html_audio_element, WEBKIT_DOM_TYPE_HTML_MEDIA_ELEMENT, G_IMPLEMENT_INTERFACE(WEBKIT_DOM_TYPE_EVENT_TARGET, webkit_dom_event_target_init))

static void webkit_dom_html_audio_element_class_init(WebKitDOMHTMLAudioElementClass* requestClass)
{
    UNUSED_PARAM(requestClass);
}

static void webkit_dom_html_audio_element_init(WebKitDOMHTMLAudioElement* request)
{
    UNUSED_PARAM(request);
}

