/*
 *  This file is part of the WebKit open source project.
 *  This file has been generated by generate-bindings.pl. DO NOT MODIFY!
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#include "config.h"
#include "WebKitDOMSpeechSynthesisUtterance.h"

#include "CSSImportRule.h"
#include "DOMObjectCache.h"
#include "Document.h"
#include "ExceptionCode.h"
#include "ExceptionCodeDescription.h"
#include "GObjectEventListener.h"
#include "JSMainThreadExecState.h"
#include "WebKitDOMEventPrivate.h"
#include "WebKitDOMEventTarget.h"
#include "WebKitDOMPrivate.h"
#include "WebKitDOMSpeechSynthesisUtterancePrivate.h"
#include "WebKitDOMSpeechSynthesisVoicePrivate.h"
#include "gobject/ConvertToUTF8String.h"
#include <wtf/GetPtr.h>
#include <wtf/RefPtr.h>

#define WEBKIT_DOM_SPEECH_SYNTHESIS_UTTERANCE_GET_PRIVATE(obj) G_TYPE_INSTANCE_GET_PRIVATE(obj, WEBKIT_DOM_TYPE_SPEECH_SYNTHESIS_UTTERANCE, WebKitDOMSpeechSynthesisUtterancePrivate)

typedef struct _WebKitDOMSpeechSynthesisUtterancePrivate {
#if ENABLE(SPEECH_SYNTHESIS)
    RefPtr<WebCore::SpeechSynthesisUtterance> coreObject;
#endif // ENABLE(SPEECH_SYNTHESIS)
} WebKitDOMSpeechSynthesisUtterancePrivate;

#if ENABLE(SPEECH_SYNTHESIS)

namespace WebKit {

WebKitDOMSpeechSynthesisUtterance* kit(WebCore::SpeechSynthesisUtterance* obj)
{
    if (!obj)
        return 0;

    if (gpointer ret = DOMObjectCache::get(obj))
        return WEBKIT_DOM_SPEECH_SYNTHESIS_UTTERANCE(ret);

    return wrapSpeechSynthesisUtterance(obj);
}

WebCore::SpeechSynthesisUtterance* core(WebKitDOMSpeechSynthesisUtterance* request)
{
    return request ? static_cast<WebCore::SpeechSynthesisUtterance*>(WEBKIT_DOM_OBJECT(request)->coreObject) : 0;
}

WebKitDOMSpeechSynthesisUtterance* wrapSpeechSynthesisUtterance(WebCore::SpeechSynthesisUtterance* coreObject)
{
    ASSERT(coreObject);
    return WEBKIT_DOM_SPEECH_SYNTHESIS_UTTERANCE(g_object_new(WEBKIT_DOM_TYPE_SPEECH_SYNTHESIS_UTTERANCE, "core-object", coreObject, nullptr));
}

} // namespace WebKit

#endif // ENABLE(SPEECH_SYNTHESIS)

static gboolean webkit_dom_speech_synthesis_utterance_dispatch_event(WebKitDOMEventTarget* target, WebKitDOMEvent* event, GError** error)
{
#if ENABLE(SPEECH_SYNTHESIS)
    WebCore::Event* coreEvent = WebKit::core(event);
    if (!coreEvent)
        return false;
    WebCore::SpeechSynthesisUtterance* coreTarget = static_cast<WebCore::SpeechSynthesisUtterance*>(WEBKIT_DOM_OBJECT(target)->coreObject);

    WebCore::ExceptionCode ec = 0;
    gboolean result = coreTarget->dispatchEventForBindings(*coreEvent, ec);
    if (ec) {
        WebCore::ExceptionCodeDescription description(ec);
        g_set_error_literal(error, g_quark_from_string("WEBKIT_DOM"), description.code, description.name);
    }
    return result;
#else
    UNUSED_PARAM(target);
    UNUSED_PARAM(event);
    UNUSED_PARAM(error);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Speech Synthesis")
    return false;
#endif // ENABLE(SPEECH_SYNTHESIS)
}

static gboolean webkit_dom_speech_synthesis_utterance_add_event_listener(WebKitDOMEventTarget* target, const char* eventName, GClosure* handler, gboolean useCapture)
{
#if ENABLE(SPEECH_SYNTHESIS)
    WebCore::SpeechSynthesisUtterance* coreTarget = static_cast<WebCore::SpeechSynthesisUtterance*>(WEBKIT_DOM_OBJECT(target)->coreObject);
    return WebCore::GObjectEventListener::addEventListener(G_OBJECT(target), coreTarget, eventName, handler, useCapture);
#else
    UNUSED_PARAM(target);
    UNUSED_PARAM(eventName);
    UNUSED_PARAM(handler);
    UNUSED_PARAM(useCapture);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Speech Synthesis")
    return false;
#endif // ENABLE(SPEECH_SYNTHESIS)
}

static gboolean webkit_dom_speech_synthesis_utterance_remove_event_listener(WebKitDOMEventTarget* target, const char* eventName, GClosure* handler, gboolean useCapture)
{
#if ENABLE(SPEECH_SYNTHESIS)
    WebCore::SpeechSynthesisUtterance* coreTarget = static_cast<WebCore::SpeechSynthesisUtterance*>(WEBKIT_DOM_OBJECT(target)->coreObject);
    return WebCore::GObjectEventListener::removeEventListener(G_OBJECT(target), coreTarget, eventName, handler, useCapture);
#else
    UNUSED_PARAM(target);
    UNUSED_PARAM(eventName);
    UNUSED_PARAM(handler);
    UNUSED_PARAM(useCapture);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Speech Synthesis")
    return false;
#endif // ENABLE(SPEECH_SYNTHESIS)
}

static void webkit_dom_event_target_init(WebKitDOMEventTargetIface* iface)
{
    iface->dispatch_event = webkit_dom_speech_synthesis_utterance_dispatch_event;
    iface->add_event_listener = webkit_dom_speech_synthesis_utterance_add_event_listener;
    iface->remove_event_listener = webkit_dom_speech_synthesis_utterance_remove_event_listener;
}

G_DEFINE_TYPE_WITH_CODE(WebKitDOMSpeechSynthesisUtterance, webkit_dom_speech_synthesis_utterance, WEBKIT_DOM_TYPE_OBJECT, G_IMPLEMENT_INTERFACE(WEBKIT_DOM_TYPE_EVENT_TARGET, webkit_dom_event_target_init))

enum {
    PROP_0,
    PROP_TEXT,
    PROP_LANG,
    PROP_VOICE,
    PROP_VOLUME,
    PROP_RATE,
    PROP_PITCH,
};

static void webkit_dom_speech_synthesis_utterance_finalize(GObject* object)
{
    WebKitDOMSpeechSynthesisUtterancePrivate* priv = WEBKIT_DOM_SPEECH_SYNTHESIS_UTTERANCE_GET_PRIVATE(object);
#if ENABLE(SPEECH_SYNTHESIS)
    WebKit::DOMObjectCache::forget(priv->coreObject.get());
#endif // ENABLE(SPEECH_SYNTHESIS)
    priv->~WebKitDOMSpeechSynthesisUtterancePrivate();
    G_OBJECT_CLASS(webkit_dom_speech_synthesis_utterance_parent_class)->finalize(object);
}

static void webkit_dom_speech_synthesis_utterance_set_property(GObject* object, guint propertyId, const GValue* value, GParamSpec* pspec)
{
    WebKitDOMSpeechSynthesisUtterance* self = WEBKIT_DOM_SPEECH_SYNTHESIS_UTTERANCE(object);

    switch (propertyId) {
    case PROP_TEXT:
        webkit_dom_speech_synthesis_utterance_set_text(self, g_value_get_string(value));
        break;
    case PROP_LANG:
        webkit_dom_speech_synthesis_utterance_set_lang(self, g_value_get_string(value));
        break;
    case PROP_VOLUME:
        webkit_dom_speech_synthesis_utterance_set_volume(self, g_value_get_float(value));
        break;
    case PROP_RATE:
        webkit_dom_speech_synthesis_utterance_set_rate(self, g_value_get_float(value));
        break;
    case PROP_PITCH:
        webkit_dom_speech_synthesis_utterance_set_pitch(self, g_value_get_float(value));
        break;
    default:
        G_OBJECT_WARN_INVALID_PROPERTY_ID(object, propertyId, pspec);
        break;
    }
}

static void webkit_dom_speech_synthesis_utterance_get_property(GObject* object, guint propertyId, GValue* value, GParamSpec* pspec)
{
    WebKitDOMSpeechSynthesisUtterance* self = WEBKIT_DOM_SPEECH_SYNTHESIS_UTTERANCE(object);

    switch (propertyId) {
    case PROP_TEXT:
        g_value_take_string(value, webkit_dom_speech_synthesis_utterance_get_text(self));
        break;
    case PROP_LANG:
        g_value_take_string(value, webkit_dom_speech_synthesis_utterance_get_lang(self));
        break;
    case PROP_VOICE:
        g_value_set_object(value, webkit_dom_speech_synthesis_utterance_get_voice(self));
        break;
    case PROP_VOLUME:
        g_value_set_float(value, webkit_dom_speech_synthesis_utterance_get_volume(self));
        break;
    case PROP_RATE:
        g_value_set_float(value, webkit_dom_speech_synthesis_utterance_get_rate(self));
        break;
    case PROP_PITCH:
        g_value_set_float(value, webkit_dom_speech_synthesis_utterance_get_pitch(self));
        break;
    default:
        G_OBJECT_WARN_INVALID_PROPERTY_ID(object, propertyId, pspec);
        break;
    }
}

static GObject* webkit_dom_speech_synthesis_utterance_constructor(GType type, guint constructPropertiesCount, GObjectConstructParam* constructProperties)
{
    GObject* object = G_OBJECT_CLASS(webkit_dom_speech_synthesis_utterance_parent_class)->constructor(type, constructPropertiesCount, constructProperties);
#if ENABLE(SPEECH_SYNTHESIS)
    WebKitDOMSpeechSynthesisUtterancePrivate* priv = WEBKIT_DOM_SPEECH_SYNTHESIS_UTTERANCE_GET_PRIVATE(object);
    priv->coreObject = static_cast<WebCore::SpeechSynthesisUtterance*>(WEBKIT_DOM_OBJECT(object)->coreObject);
    WebKit::DOMObjectCache::put(priv->coreObject.get(), object);
#endif // ENABLE(SPEECH_SYNTHESIS)
    return object;
}

static void webkit_dom_speech_synthesis_utterance_class_init(WebKitDOMSpeechSynthesisUtteranceClass* requestClass)
{
    GObjectClass* gobjectClass = G_OBJECT_CLASS(requestClass);
    g_type_class_add_private(gobjectClass, sizeof(WebKitDOMSpeechSynthesisUtterancePrivate));
    gobjectClass->constructor = webkit_dom_speech_synthesis_utterance_constructor;
    gobjectClass->finalize = webkit_dom_speech_synthesis_utterance_finalize;
    gobjectClass->set_property = webkit_dom_speech_synthesis_utterance_set_property;
    gobjectClass->get_property = webkit_dom_speech_synthesis_utterance_get_property;

    g_object_class_install_property(
        gobjectClass,
        PROP_TEXT,
        g_param_spec_string(
            "text",
            "SpeechSynthesisUtterance:text",
            "read-write gchar* SpeechSynthesisUtterance:text",
            "",
            WEBKIT_PARAM_READWRITE));

    g_object_class_install_property(
        gobjectClass,
        PROP_LANG,
        g_param_spec_string(
            "lang",
            "SpeechSynthesisUtterance:lang",
            "read-write gchar* SpeechSynthesisUtterance:lang",
            "",
            WEBKIT_PARAM_READWRITE));

    g_object_class_install_property(
        gobjectClass,
        PROP_VOICE,
        g_param_spec_object(
            "voice",
            "SpeechSynthesisUtterance:voice",
            "read-only WebKitDOMSpeechSynthesisVoice* SpeechSynthesisUtterance:voice",
            WEBKIT_DOM_TYPE_SPEECH_SYNTHESIS_VOICE,
            WEBKIT_PARAM_READABLE));

    g_object_class_install_property(
        gobjectClass,
        PROP_VOLUME,
        g_param_spec_float(
            "volume",
            "SpeechSynthesisUtterance:volume",
            "read-write gfloat SpeechSynthesisUtterance:volume",
            -G_MAXFLOAT, G_MAXFLOAT, 0,
            WEBKIT_PARAM_READWRITE));

    g_object_class_install_property(
        gobjectClass,
        PROP_RATE,
        g_param_spec_float(
            "rate",
            "SpeechSynthesisUtterance:rate",
            "read-write gfloat SpeechSynthesisUtterance:rate",
            -G_MAXFLOAT, G_MAXFLOAT, 0,
            WEBKIT_PARAM_READWRITE));

    g_object_class_install_property(
        gobjectClass,
        PROP_PITCH,
        g_param_spec_float(
            "pitch",
            "SpeechSynthesisUtterance:pitch",
            "read-write gfloat SpeechSynthesisUtterance:pitch",
            -G_MAXFLOAT, G_MAXFLOAT, 0,
            WEBKIT_PARAM_READWRITE));

}

static void webkit_dom_speech_synthesis_utterance_init(WebKitDOMSpeechSynthesisUtterance* request)
{
    WebKitDOMSpeechSynthesisUtterancePrivate* priv = WEBKIT_DOM_SPEECH_SYNTHESIS_UTTERANCE_GET_PRIVATE(request);
    new (priv) WebKitDOMSpeechSynthesisUtterancePrivate();
}

gchar* webkit_dom_speech_synthesis_utterance_get_text(WebKitDOMSpeechSynthesisUtterance* self)
{
#if ENABLE(SPEECH_SYNTHESIS)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_SPEECH_SYNTHESIS_UTTERANCE(self), 0);
    WebCore::SpeechSynthesisUtterance* item = WebKit::core(self);
    gchar* result = convertToUTF8String(item->text());
    return result;
#else
    UNUSED_PARAM(self);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Speech Synthesis")
    return 0;
#endif /* ENABLE(SPEECH_SYNTHESIS) */
}

void webkit_dom_speech_synthesis_utterance_set_text(WebKitDOMSpeechSynthesisUtterance* self, const gchar* value)
{
#if ENABLE(SPEECH_SYNTHESIS)
    WebCore::JSMainThreadNullState state;
    g_return_if_fail(WEBKIT_DOM_IS_SPEECH_SYNTHESIS_UTTERANCE(self));
    g_return_if_fail(value);
    WebCore::SpeechSynthesisUtterance* item = WebKit::core(self);
    WTF::String convertedValue = WTF::String::fromUTF8(value);
    item->setText(convertedValue);
#else
    UNUSED_PARAM(self);
    UNUSED_PARAM(value);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Speech Synthesis")
#endif /* ENABLE(SPEECH_SYNTHESIS) */
}

gchar* webkit_dom_speech_synthesis_utterance_get_lang(WebKitDOMSpeechSynthesisUtterance* self)
{
#if ENABLE(SPEECH_SYNTHESIS)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_SPEECH_SYNTHESIS_UTTERANCE(self), 0);
    WebCore::SpeechSynthesisUtterance* item = WebKit::core(self);
    gchar* result = convertToUTF8String(item->lang());
    return result;
#else
    UNUSED_PARAM(self);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Speech Synthesis")
    return 0;
#endif /* ENABLE(SPEECH_SYNTHESIS) */
}

void webkit_dom_speech_synthesis_utterance_set_lang(WebKitDOMSpeechSynthesisUtterance* self, const gchar* value)
{
#if ENABLE(SPEECH_SYNTHESIS)
    WebCore::JSMainThreadNullState state;
    g_return_if_fail(WEBKIT_DOM_IS_SPEECH_SYNTHESIS_UTTERANCE(self));
    g_return_if_fail(value);
    WebCore::SpeechSynthesisUtterance* item = WebKit::core(self);
    WTF::String convertedValue = WTF::String::fromUTF8(value);
    item->setLang(convertedValue);
#else
    UNUSED_PARAM(self);
    UNUSED_PARAM(value);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Speech Synthesis")
#endif /* ENABLE(SPEECH_SYNTHESIS) */
}

WebKitDOMSpeechSynthesisVoice* webkit_dom_speech_synthesis_utterance_get_voice(WebKitDOMSpeechSynthesisUtterance* self)
{
#if ENABLE(SPEECH_SYNTHESIS)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_SPEECH_SYNTHESIS_UTTERANCE(self), 0);
    WebCore::SpeechSynthesisUtterance* item = WebKit::core(self);
    RefPtr<WebCore::SpeechSynthesisVoice> gobjectResult = WTF::getPtr(item->voice());
    return WebKit::kit(gobjectResult.get());
#else
    UNUSED_PARAM(self);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Speech Synthesis")
    return 0;
#endif /* ENABLE(SPEECH_SYNTHESIS) */
}

void webkit_dom_speech_synthesis_utterance_set_voice(WebKitDOMSpeechSynthesisUtterance* self, WebKitDOMSpeechSynthesisVoice* value)
{
#if ENABLE(SPEECH_SYNTHESIS)
    WebCore::JSMainThreadNullState state;
    g_return_if_fail(WEBKIT_DOM_IS_SPEECH_SYNTHESIS_UTTERANCE(self));
    g_return_if_fail(WEBKIT_DOM_IS_SPEECH_SYNTHESIS_VOICE(value));
    WebCore::SpeechSynthesisUtterance* item = WebKit::core(self);
    WebCore::SpeechSynthesisVoice* convertedValue = WebKit::core(value);
    item->setVoice(convertedValue);
#else
    UNUSED_PARAM(self);
    UNUSED_PARAM(value);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Speech Synthesis")
#endif /* ENABLE(SPEECH_SYNTHESIS) */
}

gfloat webkit_dom_speech_synthesis_utterance_get_volume(WebKitDOMSpeechSynthesisUtterance* self)
{
#if ENABLE(SPEECH_SYNTHESIS)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_SPEECH_SYNTHESIS_UTTERANCE(self), 0);
    WebCore::SpeechSynthesisUtterance* item = WebKit::core(self);
    gfloat result = item->volume();
    return result;
#else
    UNUSED_PARAM(self);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Speech Synthesis")
    return static_cast<gfloat>(0);
#endif /* ENABLE(SPEECH_SYNTHESIS) */
}

void webkit_dom_speech_synthesis_utterance_set_volume(WebKitDOMSpeechSynthesisUtterance* self, gfloat value)
{
#if ENABLE(SPEECH_SYNTHESIS)
    WebCore::JSMainThreadNullState state;
    g_return_if_fail(WEBKIT_DOM_IS_SPEECH_SYNTHESIS_UTTERANCE(self));
    WebCore::SpeechSynthesisUtterance* item = WebKit::core(self);
    item->setVolume(value);
#else
    UNUSED_PARAM(self);
    UNUSED_PARAM(value);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Speech Synthesis")
#endif /* ENABLE(SPEECH_SYNTHESIS) */
}

gfloat webkit_dom_speech_synthesis_utterance_get_rate(WebKitDOMSpeechSynthesisUtterance* self)
{
#if ENABLE(SPEECH_SYNTHESIS)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_SPEECH_SYNTHESIS_UTTERANCE(self), 0);
    WebCore::SpeechSynthesisUtterance* item = WebKit::core(self);
    gfloat result = item->rate();
    return result;
#else
    UNUSED_PARAM(self);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Speech Synthesis")
    return static_cast<gfloat>(0);
#endif /* ENABLE(SPEECH_SYNTHESIS) */
}

void webkit_dom_speech_synthesis_utterance_set_rate(WebKitDOMSpeechSynthesisUtterance* self, gfloat value)
{
#if ENABLE(SPEECH_SYNTHESIS)
    WebCore::JSMainThreadNullState state;
    g_return_if_fail(WEBKIT_DOM_IS_SPEECH_SYNTHESIS_UTTERANCE(self));
    WebCore::SpeechSynthesisUtterance* item = WebKit::core(self);
    item->setRate(value);
#else
    UNUSED_PARAM(self);
    UNUSED_PARAM(value);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Speech Synthesis")
#endif /* ENABLE(SPEECH_SYNTHESIS) */
}

gfloat webkit_dom_speech_synthesis_utterance_get_pitch(WebKitDOMSpeechSynthesisUtterance* self)
{
#if ENABLE(SPEECH_SYNTHESIS)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_SPEECH_SYNTHESIS_UTTERANCE(self), 0);
    WebCore::SpeechSynthesisUtterance* item = WebKit::core(self);
    gfloat result = item->pitch();
    return result;
#else
    UNUSED_PARAM(self);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Speech Synthesis")
    return static_cast<gfloat>(0);
#endif /* ENABLE(SPEECH_SYNTHESIS) */
}

void webkit_dom_speech_synthesis_utterance_set_pitch(WebKitDOMSpeechSynthesisUtterance* self, gfloat value)
{
#if ENABLE(SPEECH_SYNTHESIS)
    WebCore::JSMainThreadNullState state;
    g_return_if_fail(WEBKIT_DOM_IS_SPEECH_SYNTHESIS_UTTERANCE(self));
    WebCore::SpeechSynthesisUtterance* item = WebKit::core(self);
    item->setPitch(value);
#else
    UNUSED_PARAM(self);
    UNUSED_PARAM(value);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Speech Synthesis")
#endif /* ENABLE(SPEECH_SYNTHESIS) */
}

