/*
 *  This file is part of the WebKit open source project.
 *  This file has been generated by generate-bindings.pl. DO NOT MODIFY!
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#include "config.h"
#include "WebKitDOMUserMessageHandlersNamespace.h"

#include "CSSImportRule.h"
#include "DOMObjectCache.h"
#include "Document.h"
#include "ExceptionCode.h"
#include "ExceptionCodeDescription.h"
#include "JSMainThreadExecState.h"
#include "WebKitDOMPrivate.h"
#include "WebKitDOMUserMessageHandlersNamespacePrivate.h"
#include "gobject/ConvertToUTF8String.h"
#include <wtf/GetPtr.h>
#include <wtf/RefPtr.h>

#define WEBKIT_DOM_USER_MESSAGE_HANDLERS_NAMESPACE_GET_PRIVATE(obj) G_TYPE_INSTANCE_GET_PRIVATE(obj, WEBKIT_DOM_TYPE_USER_MESSAGE_HANDLERS_NAMESPACE, WebKitDOMUserMessageHandlersNamespacePrivate)

typedef struct _WebKitDOMUserMessageHandlersNamespacePrivate {
#if ENABLE(USER_MESSAGE_HANDLERS)
    RefPtr<WebCore::UserMessageHandlersNamespace> coreObject;
#endif // ENABLE(USER_MESSAGE_HANDLERS)
} WebKitDOMUserMessageHandlersNamespacePrivate;

#if ENABLE(USER_MESSAGE_HANDLERS)

namespace WebKit {

WebKitDOMUserMessageHandlersNamespace* kit(WebCore::UserMessageHandlersNamespace* obj)
{
    if (!obj)
        return 0;

    if (gpointer ret = DOMObjectCache::get(obj))
        return WEBKIT_DOM_USER_MESSAGE_HANDLERS_NAMESPACE(ret);

    return wrapUserMessageHandlersNamespace(obj);
}

WebCore::UserMessageHandlersNamespace* core(WebKitDOMUserMessageHandlersNamespace* request)
{
    return request ? static_cast<WebCore::UserMessageHandlersNamespace*>(WEBKIT_DOM_OBJECT(request)->coreObject) : 0;
}

WebKitDOMUserMessageHandlersNamespace* wrapUserMessageHandlersNamespace(WebCore::UserMessageHandlersNamespace* coreObject)
{
    ASSERT(coreObject);
    return WEBKIT_DOM_USER_MESSAGE_HANDLERS_NAMESPACE(g_object_new(WEBKIT_DOM_TYPE_USER_MESSAGE_HANDLERS_NAMESPACE, "core-object", coreObject, nullptr));
}

} // namespace WebKit

#endif // ENABLE(USER_MESSAGE_HANDLERS)

G_DEFINE_TYPE(WebKitDOMUserMessageHandlersNamespace, webkit_dom_user_message_handlers_namespace, WEBKIT_DOM_TYPE_OBJECT)

static void webkit_dom_user_message_handlers_namespace_finalize(GObject* object)
{
    WebKitDOMUserMessageHandlersNamespacePrivate* priv = WEBKIT_DOM_USER_MESSAGE_HANDLERS_NAMESPACE_GET_PRIVATE(object);
#if ENABLE(USER_MESSAGE_HANDLERS)
    WebKit::DOMObjectCache::forget(priv->coreObject.get());
#endif // ENABLE(USER_MESSAGE_HANDLERS)
    priv->~WebKitDOMUserMessageHandlersNamespacePrivate();
    G_OBJECT_CLASS(webkit_dom_user_message_handlers_namespace_parent_class)->finalize(object);
}

static GObject* webkit_dom_user_message_handlers_namespace_constructor(GType type, guint constructPropertiesCount, GObjectConstructParam* constructProperties)
{
    GObject* object = G_OBJECT_CLASS(webkit_dom_user_message_handlers_namespace_parent_class)->constructor(type, constructPropertiesCount, constructProperties);
#if ENABLE(USER_MESSAGE_HANDLERS)
    WebKitDOMUserMessageHandlersNamespacePrivate* priv = WEBKIT_DOM_USER_MESSAGE_HANDLERS_NAMESPACE_GET_PRIVATE(object);
    priv->coreObject = static_cast<WebCore::UserMessageHandlersNamespace*>(WEBKIT_DOM_OBJECT(object)->coreObject);
    WebKit::DOMObjectCache::put(priv->coreObject.get(), object);
#endif // ENABLE(USER_MESSAGE_HANDLERS)
    return object;
}

static void webkit_dom_user_message_handlers_namespace_class_init(WebKitDOMUserMessageHandlersNamespaceClass* requestClass)
{
    GObjectClass* gobjectClass = G_OBJECT_CLASS(requestClass);
    g_type_class_add_private(gobjectClass, sizeof(WebKitDOMUserMessageHandlersNamespacePrivate));
    gobjectClass->constructor = webkit_dom_user_message_handlers_namespace_constructor;
    gobjectClass->finalize = webkit_dom_user_message_handlers_namespace_finalize;
}

static void webkit_dom_user_message_handlers_namespace_init(WebKitDOMUserMessageHandlersNamespace* request)
{
    WebKitDOMUserMessageHandlersNamespacePrivate* priv = WEBKIT_DOM_USER_MESSAGE_HANDLERS_NAMESPACE_GET_PRIVATE(request);
    new (priv) WebKitDOMUserMessageHandlersNamespacePrivate();
}

