/*
 *  This file is part of the WebKit open source project.
 *  This file has been generated by generate-bindings.pl. DO NOT MODIFY!
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#include "config.h"
#include "WebKitDOMVideoTrackList.h"

#include "CSSImportRule.h"
#include "DOMObjectCache.h"
#include "Document.h"
#include "ExceptionCode.h"
#include "ExceptionCodeDescription.h"
#include "GObjectEventListener.h"
#include "JSMainThreadExecState.h"
#include "WebKitDOMEventPrivate.h"
#include "WebKitDOMEventTarget.h"
#include "WebKitDOMPrivate.h"
#include "WebKitDOMVideoTrackListPrivate.h"
#include "WebKitDOMVideoTrackPrivate.h"
#include "gobject/ConvertToUTF8String.h"
#include <wtf/GetPtr.h>
#include <wtf/RefPtr.h>

#define WEBKIT_DOM_VIDEO_TRACK_LIST_GET_PRIVATE(obj) G_TYPE_INSTANCE_GET_PRIVATE(obj, WEBKIT_DOM_TYPE_VIDEO_TRACK_LIST, WebKitDOMVideoTrackListPrivate)

typedef struct _WebKitDOMVideoTrackListPrivate {
#if ENABLE(VIDEO_TRACK)
    RefPtr<WebCore::VideoTrackList> coreObject;
#endif // ENABLE(VIDEO_TRACK)
} WebKitDOMVideoTrackListPrivate;

#if ENABLE(VIDEO_TRACK)

namespace WebKit {

WebKitDOMVideoTrackList* kit(WebCore::VideoTrackList* obj)
{
    if (!obj)
        return 0;

    if (gpointer ret = DOMObjectCache::get(obj))
        return WEBKIT_DOM_VIDEO_TRACK_LIST(ret);

    return wrapVideoTrackList(obj);
}

WebCore::VideoTrackList* core(WebKitDOMVideoTrackList* request)
{
    return request ? static_cast<WebCore::VideoTrackList*>(WEBKIT_DOM_OBJECT(request)->coreObject) : 0;
}

WebKitDOMVideoTrackList* wrapVideoTrackList(WebCore::VideoTrackList* coreObject)
{
    ASSERT(coreObject);
    return WEBKIT_DOM_VIDEO_TRACK_LIST(g_object_new(WEBKIT_DOM_TYPE_VIDEO_TRACK_LIST, "core-object", coreObject, nullptr));
}

} // namespace WebKit

#endif // ENABLE(VIDEO_TRACK)

static gboolean webkit_dom_video_track_list_dispatch_event(WebKitDOMEventTarget* target, WebKitDOMEvent* event, GError** error)
{
#if ENABLE(VIDEO_TRACK)
    WebCore::Event* coreEvent = WebKit::core(event);
    if (!coreEvent)
        return false;
    WebCore::VideoTrackList* coreTarget = static_cast<WebCore::VideoTrackList*>(WEBKIT_DOM_OBJECT(target)->coreObject);

    WebCore::ExceptionCode ec = 0;
    gboolean result = coreTarget->dispatchEventForBindings(*coreEvent, ec);
    if (ec) {
        WebCore::ExceptionCodeDescription description(ec);
        g_set_error_literal(error, g_quark_from_string("WEBKIT_DOM"), description.code, description.name);
    }
    return result;
#else
    UNUSED_PARAM(target);
    UNUSED_PARAM(event);
    UNUSED_PARAM(error);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video Track")
    return false;
#endif // ENABLE(VIDEO_TRACK)
}

static gboolean webkit_dom_video_track_list_add_event_listener(WebKitDOMEventTarget* target, const char* eventName, GClosure* handler, gboolean useCapture)
{
#if ENABLE(VIDEO_TRACK)
    WebCore::VideoTrackList* coreTarget = static_cast<WebCore::VideoTrackList*>(WEBKIT_DOM_OBJECT(target)->coreObject);
    return WebCore::GObjectEventListener::addEventListener(G_OBJECT(target), coreTarget, eventName, handler, useCapture);
#else
    UNUSED_PARAM(target);
    UNUSED_PARAM(eventName);
    UNUSED_PARAM(handler);
    UNUSED_PARAM(useCapture);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video Track")
    return false;
#endif // ENABLE(VIDEO_TRACK)
}

static gboolean webkit_dom_video_track_list_remove_event_listener(WebKitDOMEventTarget* target, const char* eventName, GClosure* handler, gboolean useCapture)
{
#if ENABLE(VIDEO_TRACK)
    WebCore::VideoTrackList* coreTarget = static_cast<WebCore::VideoTrackList*>(WEBKIT_DOM_OBJECT(target)->coreObject);
    return WebCore::GObjectEventListener::removeEventListener(G_OBJECT(target), coreTarget, eventName, handler, useCapture);
#else
    UNUSED_PARAM(target);
    UNUSED_PARAM(eventName);
    UNUSED_PARAM(handler);
    UNUSED_PARAM(useCapture);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video Track")
    return false;
#endif // ENABLE(VIDEO_TRACK)
}

static void webkit_dom_event_target_init(WebKitDOMEventTargetIface* iface)
{
    iface->dispatch_event = webkit_dom_video_track_list_dispatch_event;
    iface->add_event_listener = webkit_dom_video_track_list_add_event_listener;
    iface->remove_event_listener = webkit_dom_video_track_list_remove_event_listener;
}

G_DEFINE_TYPE_WITH_CODE(WebKitDOMVideoTrackList, webkit_dom_video_track_list, WEBKIT_DOM_TYPE_OBJECT, G_IMPLEMENT_INTERFACE(WEBKIT_DOM_TYPE_EVENT_TARGET, webkit_dom_event_target_init))

enum {
    PROP_0,
    PROP_LENGTH,
    PROP_SELECTED_INDEX,
};

static void webkit_dom_video_track_list_finalize(GObject* object)
{
    WebKitDOMVideoTrackListPrivate* priv = WEBKIT_DOM_VIDEO_TRACK_LIST_GET_PRIVATE(object);
#if ENABLE(VIDEO_TRACK)
    WebKit::DOMObjectCache::forget(priv->coreObject.get());
#endif // ENABLE(VIDEO_TRACK)
    priv->~WebKitDOMVideoTrackListPrivate();
    G_OBJECT_CLASS(webkit_dom_video_track_list_parent_class)->finalize(object);
}

static void webkit_dom_video_track_list_get_property(GObject* object, guint propertyId, GValue* value, GParamSpec* pspec)
{
    WebKitDOMVideoTrackList* self = WEBKIT_DOM_VIDEO_TRACK_LIST(object);

    switch (propertyId) {
    case PROP_LENGTH:
        g_value_set_ulong(value, webkit_dom_video_track_list_get_length(self));
        break;
    case PROP_SELECTED_INDEX:
        g_value_set_long(value, webkit_dom_video_track_list_get_selected_index(self));
        break;
    default:
        G_OBJECT_WARN_INVALID_PROPERTY_ID(object, propertyId, pspec);
        break;
    }
}

static GObject* webkit_dom_video_track_list_constructor(GType type, guint constructPropertiesCount, GObjectConstructParam* constructProperties)
{
    GObject* object = G_OBJECT_CLASS(webkit_dom_video_track_list_parent_class)->constructor(type, constructPropertiesCount, constructProperties);
#if ENABLE(VIDEO_TRACK)
    WebKitDOMVideoTrackListPrivate* priv = WEBKIT_DOM_VIDEO_TRACK_LIST_GET_PRIVATE(object);
    priv->coreObject = static_cast<WebCore::VideoTrackList*>(WEBKIT_DOM_OBJECT(object)->coreObject);
    WebKit::DOMObjectCache::put(priv->coreObject.get(), object);
#endif // ENABLE(VIDEO_TRACK)
    return object;
}

static void webkit_dom_video_track_list_class_init(WebKitDOMVideoTrackListClass* requestClass)
{
    GObjectClass* gobjectClass = G_OBJECT_CLASS(requestClass);
    g_type_class_add_private(gobjectClass, sizeof(WebKitDOMVideoTrackListPrivate));
    gobjectClass->constructor = webkit_dom_video_track_list_constructor;
    gobjectClass->finalize = webkit_dom_video_track_list_finalize;
    gobjectClass->get_property = webkit_dom_video_track_list_get_property;

    g_object_class_install_property(
        gobjectClass,
        PROP_LENGTH,
        g_param_spec_ulong(
            "length",
            "VideoTrackList:length",
            "read-only gulong VideoTrackList:length",
            0, G_MAXULONG, 0,
            WEBKIT_PARAM_READABLE));

    g_object_class_install_property(
        gobjectClass,
        PROP_SELECTED_INDEX,
        g_param_spec_long(
            "selected-index",
            "VideoTrackList:selected-index",
            "read-only glong VideoTrackList:selected-index",
            G_MINLONG, G_MAXLONG, 0,
            WEBKIT_PARAM_READABLE));

}

static void webkit_dom_video_track_list_init(WebKitDOMVideoTrackList* request)
{
    WebKitDOMVideoTrackListPrivate* priv = WEBKIT_DOM_VIDEO_TRACK_LIST_GET_PRIVATE(request);
    new (priv) WebKitDOMVideoTrackListPrivate();
}

WebKitDOMVideoTrack* webkit_dom_video_track_list_item(WebKitDOMVideoTrackList* self, gulong index)
{
#if ENABLE(VIDEO_TRACK)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_VIDEO_TRACK_LIST(self), 0);
    WebCore::VideoTrackList* item = WebKit::core(self);
    RefPtr<WebCore::VideoTrack> gobjectResult = WTF::getPtr(item->item(index));
    return WebKit::kit(gobjectResult.get());
#else
    UNUSED_PARAM(self);
    UNUSED_PARAM(index);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video Track")
    return 0;
#endif /* ENABLE(VIDEO_TRACK) */
}

WebKitDOMVideoTrack* webkit_dom_video_track_list_get_track_by_id(WebKitDOMVideoTrackList* self, const gchar* id)
{
#if ENABLE(VIDEO_TRACK)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_VIDEO_TRACK_LIST(self), 0);
    g_return_val_if_fail(id, 0);
    WebCore::VideoTrackList* item = WebKit::core(self);
    WTF::String convertedId = WTF::String::fromUTF8(id);
    RefPtr<WebCore::VideoTrack> gobjectResult = WTF::getPtr(item->getTrackById(convertedId));
    return WebKit::kit(gobjectResult.get());
#else
    UNUSED_PARAM(self);
    UNUSED_PARAM(id);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video Track")
    return 0;
#endif /* ENABLE(VIDEO_TRACK) */
}

gulong webkit_dom_video_track_list_get_length(WebKitDOMVideoTrackList* self)
{
#if ENABLE(VIDEO_TRACK)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_VIDEO_TRACK_LIST(self), 0);
    WebCore::VideoTrackList* item = WebKit::core(self);
    gulong result = item->length();
    return result;
#else
    UNUSED_PARAM(self);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video Track")
    return static_cast<gulong>(0);
#endif /* ENABLE(VIDEO_TRACK) */
}

glong webkit_dom_video_track_list_get_selected_index(WebKitDOMVideoTrackList* self)
{
#if ENABLE(VIDEO_TRACK)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_VIDEO_TRACK_LIST(self), 0);
    WebCore::VideoTrackList* item = WebKit::core(self);
    glong result = item->selectedIndex();
    return result;
#else
    UNUSED_PARAM(self);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video Track")
    return static_cast<glong>(0);
#endif /* ENABLE(VIDEO_TRACK) */
}

