/*
 *  This file is part of the WebKit open source project.
 *  This file has been generated by generate-bindings.pl. DO NOT MODIFY!
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#include "config.h"
#include "WebKitDOMWebKitNamespace.h"

#include "CSSImportRule.h"
#include "DOMObjectCache.h"
#include "Document.h"
#include "ExceptionCode.h"
#include "ExceptionCodeDescription.h"
#include "JSMainThreadExecState.h"
#include "WebKitDOMPrivate.h"
#include "WebKitDOMUserMessageHandlersNamespacePrivate.h"
#include "WebKitDOMWebKitNamespacePrivate.h"
#include "gobject/ConvertToUTF8String.h"
#include <wtf/GetPtr.h>
#include <wtf/RefPtr.h>

#define WEBKIT_DOM_WEBKIT_NAMESPACE_GET_PRIVATE(obj) G_TYPE_INSTANCE_GET_PRIVATE(obj, WEBKIT_DOM_TYPE_WEBKIT_NAMESPACE, WebKitDOMWebKitNamespacePrivate)

typedef struct _WebKitDOMWebKitNamespacePrivate {
#if ENABLE(USER_MESSAGE_HANDLERS)
    RefPtr<WebCore::WebKitNamespace> coreObject;
#endif // ENABLE(USER_MESSAGE_HANDLERS)
} WebKitDOMWebKitNamespacePrivate;

#if ENABLE(USER_MESSAGE_HANDLERS)

namespace WebKit {

WebKitDOMWebKitNamespace* kit(WebCore::WebKitNamespace* obj)
{
    if (!obj)
        return 0;

    if (gpointer ret = DOMObjectCache::get(obj))
        return WEBKIT_DOM_WEBKIT_NAMESPACE(ret);

    return wrapWebKitNamespace(obj);
}

WebCore::WebKitNamespace* core(WebKitDOMWebKitNamespace* request)
{
    return request ? static_cast<WebCore::WebKitNamespace*>(WEBKIT_DOM_OBJECT(request)->coreObject) : 0;
}

WebKitDOMWebKitNamespace* wrapWebKitNamespace(WebCore::WebKitNamespace* coreObject)
{
    ASSERT(coreObject);
    return WEBKIT_DOM_WEBKIT_NAMESPACE(g_object_new(WEBKIT_DOM_TYPE_WEBKIT_NAMESPACE, "core-object", coreObject, nullptr));
}

} // namespace WebKit

#endif // ENABLE(USER_MESSAGE_HANDLERS)

G_DEFINE_TYPE(WebKitDOMWebKitNamespace, webkit_dom_webkit_namespace, WEBKIT_DOM_TYPE_OBJECT)

enum {
    PROP_0,
    PROP_MESSAGE_HANDLERS,
};

static void webkit_dom_webkit_namespace_finalize(GObject* object)
{
    WebKitDOMWebKitNamespacePrivate* priv = WEBKIT_DOM_WEBKIT_NAMESPACE_GET_PRIVATE(object);
#if ENABLE(USER_MESSAGE_HANDLERS)
    WebKit::DOMObjectCache::forget(priv->coreObject.get());
#endif // ENABLE(USER_MESSAGE_HANDLERS)
    priv->~WebKitDOMWebKitNamespacePrivate();
    G_OBJECT_CLASS(webkit_dom_webkit_namespace_parent_class)->finalize(object);
}

static void webkit_dom_webkit_namespace_get_property(GObject* object, guint propertyId, GValue* value, GParamSpec* pspec)
{
    WebKitDOMWebKitNamespace* self = WEBKIT_DOM_WEBKIT_NAMESPACE(object);

    switch (propertyId) {
    case PROP_MESSAGE_HANDLERS:
        g_value_set_object(value, webkit_dom_webkit_namespace_get_message_handlers(self));
        break;
    default:
        G_OBJECT_WARN_INVALID_PROPERTY_ID(object, propertyId, pspec);
        break;
    }
}

static GObject* webkit_dom_webkit_namespace_constructor(GType type, guint constructPropertiesCount, GObjectConstructParam* constructProperties)
{
    GObject* object = G_OBJECT_CLASS(webkit_dom_webkit_namespace_parent_class)->constructor(type, constructPropertiesCount, constructProperties);
#if ENABLE(USER_MESSAGE_HANDLERS)
    WebKitDOMWebKitNamespacePrivate* priv = WEBKIT_DOM_WEBKIT_NAMESPACE_GET_PRIVATE(object);
    priv->coreObject = static_cast<WebCore::WebKitNamespace*>(WEBKIT_DOM_OBJECT(object)->coreObject);
    WebKit::DOMObjectCache::put(priv->coreObject.get(), object);
#endif // ENABLE(USER_MESSAGE_HANDLERS)
    return object;
}

static void webkit_dom_webkit_namespace_class_init(WebKitDOMWebKitNamespaceClass* requestClass)
{
    GObjectClass* gobjectClass = G_OBJECT_CLASS(requestClass);
    g_type_class_add_private(gobjectClass, sizeof(WebKitDOMWebKitNamespacePrivate));
    gobjectClass->constructor = webkit_dom_webkit_namespace_constructor;
    gobjectClass->finalize = webkit_dom_webkit_namespace_finalize;
    gobjectClass->get_property = webkit_dom_webkit_namespace_get_property;

    g_object_class_install_property(
        gobjectClass,
        PROP_MESSAGE_HANDLERS,
        g_param_spec_object(
            "message-handlers",
            "WebKitNamespace:message-handlers",
            "read-only WebKitDOMUserMessageHandlersNamespace* WebKitNamespace:message-handlers",
            WEBKIT_DOM_TYPE_USER_MESSAGE_HANDLERS_NAMESPACE,
            WEBKIT_PARAM_READABLE));

}

static void webkit_dom_webkit_namespace_init(WebKitDOMWebKitNamespace* request)
{
    WebKitDOMWebKitNamespacePrivate* priv = WEBKIT_DOM_WEBKIT_NAMESPACE_GET_PRIVATE(request);
    new (priv) WebKitDOMWebKitNamespacePrivate();
}

WebKitDOMUserMessageHandlersNamespace* webkit_dom_webkit_namespace_get_message_handlers(WebKitDOMWebKitNamespace* self)
{
#if ENABLE(USER_MESSAGE_HANDLERS)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_WEBKIT_NAMESPACE(self), 0);
    WebCore::WebKitNamespace* item = WebKit::core(self);
    RefPtr<WebCore::UserMessageHandlersNamespace> gobjectResult = WTF::getPtr(item->messageHandlers());
    return WebKit::kit(gobjectResult.get());
#else
    UNUSED_PARAM(self);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("User Message Handlers")
    return 0;
#endif /* ENABLE(USER_MESSAGE_HANDLERS) */
}

